/* ================================================================================
 *	File:		pctel.h
 *
 *	    Copyright (C) 1999, PCtel, Inc. All rights reserved.
 *
 *	Purpose:	Header file for ptserial.c
 *
 *	Author:		William Hsu <william_hsu@pctel.com>
 *
 *	Date:		04/15/99
 *
 *	Revision History:
 *
 *	Date		Who		What
 *	----		---		----
 *  04/15/99	whsu	Creation
 * ================================================================================
 */

#ifndef _PCTEL_H
#define _PCTEL_H

#include <linux/version.h>

/* 0x50 is just a magic number to make these relatively unique ('P')  */
#define PCTEL_IOCTL_COUNTRY		     0x5001
#define PCTEL_IOCTL_COUNTRY_REPORT	     0x5002   /* robertju */
#define PCTEL_IOCTL_GET_AUDIO_ON  	     0x5010
#define PCTEL_IOCTL_GET_AUDIO_BUFFER         0x5011

#ifndef ATTR_REGPARM
#if ( LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,0))
#define ATTR_REGPARM()  __attribute__((regparm(0)))
#else
#define ATTR_REGPARM()
#endif /* KERNEL_2.6.0 */
#endif /* ATTR_REGPARM() */

/* Defined in Controller */
extern unsigned long GlobalTimer;

extern void modem_main(void);

extern void PctelInitCtrlVars(int country) ATTR_REGPARM();

/* Defined in DSP */
extern void dspMain(void);

/* pctel module (ptmodule.c) functions */
void Pctel_module_init(void);
void Pctel_module_free(void);
int Pctel_module_is_free(void);

#endif /* _PCTEL_H */

