# $Id: vuart.s,v 1.1 2004/04/11 18:52:35 robert Exp $

.file   "vuart.c"
.version        "01.01"
gcc2_compiled.:

.global  COM_Vier
.type    COM_Vier, @object
.size    COM_Vier,1

.global  COM_Viir
.type    COM_Viir, @object
.size    COM_Viir,1

.global  COM_Vlcr
.type    COM_Vlcr, @object
.size    COM_Vlcr,1

.global  COM_Vmcr
.type    COM_Vmcr, @object
.size    COM_Vmcr,1

.global  COM_Vlsr
.type    COM_Vlsr, @object
.size    COM_Vlsr,1

.global  COM_Vmsr
.type    COM_Vmsr, @object
.size    COM_Vmsr,1

.global  COM_Vscr
.type    COM_Vscr, @object
.size    COM_Vscr,1

.global  COM_Vdll
.type    COM_Vdll, @object
.size    COM_Vdll,2

.global  get_uart_rx
.type    get_uart_rx, @function

.comm COM_RxQcount, 0x2
.comm vuart_info, 0x2018, 0x20   #0x20 is alignment!!

.global  get_uart_ier
.type    get_uart_ier, @function

.global  get_uart_iir
.type    get_uart_iir, @function

.comm COM_TxQcount, 0x2

.global  get_uart_lcr
.type    get_uart_lcr, @function

.global  get_uart_mcr
.type    get_uart_mcr, @function

.global  get_uart_lsr
.type    get_uart_lsr, @function

.global  get_uart_msr
.type    get_uart_msr, @function

.global  get_uart_scr
.type    get_uart_scr, @function

.global  get_uart_dll
.type    get_uart_dll, @function

.global  get_uart_dlm
.type    get_uart_dlm, @function

.global  put_uart_tx
.type    put_uart_tx, @function

.global  put_uart_ier
.type    put_uart_ier, @function

.global  put_uart_iir
.type    put_uart_iir, @function

.global  put_uart_lcr
.type    put_uart_lcr, @function

.global  put_uart_mcr
.type    put_uart_mcr, @function

.global  put_uart_lsr
.type    put_uart_lsr, @function

.global  put_uart_msr
.type    put_uart_msr, @function

.global  put_uart_scr
.type    put_uart_scr, @function

.global  put_uart_dll
.type    put_uart_dll, @function

.global  put_uart_dlm
.type    put_uart_dlm, @function

.global  PctelInitVUartVars
.type    PctelInitVUartVars, @function
##################################################

.lcomm com_viir.6 0x2
.type  com_viir.6,@object

.section .data

COM_Vier: .byte 0x0
COM_Viir: .byte 0x0
COM_Vlcr: .byte 0x0
COM_Vmcr: .byte 0x0
COM_Vlsr: .byte 0x0
COM_Vmsr: .byte 0x0
COM_Vscr: .word 0x0
COM_Vdll: .word 0x0

.section .bss

.section .text
.align 16

get_uart_rx:
    cmpw   $0x0,(COM_RxQcount)

    je     1f
    mov    (vuart_info+0xc),%eax
    mov    (vuart_info+0x1010)(%eax),%al
    incl   (vuart_info+0xc)
    andl   $0xfff,(vuart_info+0xc)
    decw   (COM_RxQcount)
    and    $0xff,%eax
    ret
  1:
    mov    (vuart_info+0xc),%eax
    movzbl (vuart_info+0x1010)(%eax),%eax
    ret
.L1:
.size get_uart_rx,.L1-get_uart_rx


.balign 4
get_uart_ier:
    movzbl  (COM_Vier),%eax
    ret
.L2:
.size get_uart_ier,.L2-get_uart_ier


.balign 4
get_uart_iir:
    testb  $0x1,(vuart_info+0x2010)
    je     1f
    cmpw   $0x7f,(COM_TxQcount)
    ja     1f
    orb    $0x2,(COM_Viir)
    andb   $0xfe,(vuart_info+0x2010)
    jmp    2f
  .balign 8
  1:
    andb   $0xfd,(COM_Viir)
  2:
    andb   $0xf0,(vuart_info+0x2014)
    mov    (COM_Viir),%al
    and    (COM_Vier),%al
    and    $0xff,%eax
    mov    %ax,(com_viir.6)
    testb  $0x4,(com_viir.6)
    je     3f
    orb    $0x6,(vuart_info+0x2014)
    jmp    4f
  3:
    testb  $0x1,(com_viir.6)
    je     5f
    orb    $0x4,(vuart_info+0x2014)
    jmp    4f
  5:
    testb  $0x2,(com_viir.6)
    je     6f
    orb    $0x2,(vuart_info+0x2014)
    jmp    4f
    .balign 8
  6:
    testb  $0x8,(com_viir.6)
    je     7f
    mov    (vuart_info+0x2014),%al
    jmp    4f
  7:
    orb    $0x1,(vuart_info+0x2014)
  4:
    movzbl (vuart_info+0x2014),%eax
    ret
.L3:
.size get_uart_iir,.L3-get_uart_iir


.balign 4
get_uart_lcr:
    movzbl (COM_Vlcr),%eax
    ret
.L4:
.size get_uart_lcr,.L4-get_uart_lcr


.balign 4
get_uart_mcr:
    movzbl (COM_Vmcr),%eax
    ret
.L5:
.size get_uart_mcr,.L5-get_uart_mcr


.balign 4
get_uart_lsr:
    cmpw   $0x0,(COM_RxQcount)
    jne    1f
    andb   $0xfe,(COM_Vlsr)
    andb   $0xfe,(COM_Viir)
    jmp    2f
  .balign 8
  1:
    orb    $0x1,(COM_Vlsr)
    orb    $0x1,(COM_Viir)
  2:
    cmpw   $0x7f,(COM_TxQcount)
    ja     3f
    orb    $0x60,(COM_Vlsr)
    jmp    4f
  3:
    andb   $0x9f,(COM_Vlsr)
  4:
    movzbl (COM_Vlsr),%eax
    ret
.L6:
.size get_uart_lsr,.L6-get_uart_lsr


.balign 4
get_uart_msr:
    andb   $0xf0,(COM_Vmsr)
    mov    (COM_Vmsr),%dl
    xor    (vuart_info+0x2015),%dl
    shr    $0x4,%dl
    mov    %dl,%al
    and    $0x8,%al
    and    (COM_Vier),%al
    je     1f
    orb    $0x8,(COM_Viir)
  1:
    or     (COM_Vmsr),%dl
    mov    %dl,(vuart_info+0x2015)
    movzbl %dl,%eax
    ret
.L7:
.size get_uart_msr,.L7-get_uart_msr


.balign 4
get_uart_scr:
    movzbl (COM_Vscr),%eax
    ret
.L8:
.size get_uart_scr,.L8-get_uart_scr


.balign 4
get_uart_dll:
    movzbl (COM_Vdll),%eax
    ret
.L9:
.size get_uart_dll,.L9-get_uart_dll


.balign 4
get_uart_dlm:
    movzbl (COM_Vdll+0x1),%eax
    ret
.L10:
.size get_uart_dlm,.L10-get_uart_dlm


.balign 4
put_uart_tx:
    mov    0x4(%esp,1),%ecx
    movzwl (COM_TxQcount),%edx
    mov    $0x1000,%eax
    sub    %edx,%eax
    cmp    $0x2,%eax
    jle    1f
    mov    (vuart_info),%eax
    mov    %cl,(vuart_info+0x10)(%eax)
    incl   (vuart_info)
    andl   $0xfff,(vuart_info)
    incw   (COM_TxQcount)
    orb    $0x1,(vuart_info+0x2010)
  1:
    ret
.L11:
.size put_uart_tx,.L11-put_uart_tx


.balign 4
put_uart_ier:
    mov    0x4(%esp,1),%eax
    mov    %al,(COM_Vier)
    ret
.L12:
.size put_uart_ier,.L12-put_uart_ier


.balign 4
put_uart_iir:
    ret
.L13:
.size put_uart_iir,.L13-put_uart_iir


.balign 4
put_uart_lcr:
    mov    0x4(%esp,1),%eax
    mov    %al,(COM_Vlcr)
    ret
.L14:
.size put_uart_lcr,.L14-put_uart_lcr


.balign 4
put_uart_mcr:
    mov    0x4(%esp,1),%eax
    mov    %al,(COM_Vmcr)
    ret
.L15:
.size put_uart_mcr,.L15-put_uart_mcr


.balign 4
put_uart_lsr:
    mov    0x4(%esp,1),%eax
    mov    %al,(COM_Vlsr)
    ret
.L16:
.size put_uart_lsr,.L16-put_uart_lsr


.balign 4
put_uart_msr:
    mov    0x4(%esp,1),%eax
    mov    %al,(COM_Vmsr)
    ret
.L17:
.size put_uart_msr,.L17-put_uart_msr


.balign 4
put_uart_scr:
    mov    0x4(%esp,1),%eax
    mov    %al,(COM_Vscr)
    ret
.L18:
.size put_uart_scr,.L18-put_uart_scr


.balign 4
put_uart_dll:
    mov    0x4(%esp,1),%al
    movb   $0x0,(COM_Vdll)
    and    $0xff,%eax
    or     %ax,(COM_Vdll)
    ret
.L19:
.size put_uart_dll,.L19-put_uart_dll


.balign 4
put_uart_dlm:
    mov    0x4(%esp,1),%al
    mov    (COM_Vdll),%dx
    mov    $0x0,%dh
    mov    %dx,(COM_Vdll)
    shl    $0x8,%ax
    or     %ax,(COM_Vdll)
    ret
.L20:
.size put_uart_dlm,.L20-put_uart_dlm

.balign 4
PctelInitVUartVars:
    movw   $0x0,(COM_TxQcount)
    movl   $0x0,(vuart_info)
    movl   $0x0,(vuart_info+0x4)
    movw   $0x0,(COM_RxQcount)
    movl   $0x0,(vuart_info+0x8)
    movl   $0x0,(vuart_info+0xc)
    orb    $0x1,(vuart_info+0x2010)
    movb   $0x0,(vuart_info+0x2014)
    movb   $0x0,(vuart_info+0x2015)
    ret
.L21:
.size PctelInitVUartVars,.L21-PctelInitVUartVars


.ident  "GCC: (GNU) egcs-2.91.66 19990314/Linux (egcs-1.1.2 release)"
